// *****************************************
// *                                       *
// * LEVEL.CC                              *
// *                                       *
// * Levelin ksittely                     *
// *                                       *
// * MineBombers level editor              *
// * (C) 1998-1999                         *
// * Yrj Kari-Koskinen, Sampo Lankinen    *
// *                                       *
// *****************************************


// Lukee 'fn'-tiedostosta palikat 'level':_iin
int lue_leveli(const char *fn, unsigned char *level) {
  int x,y;

  FILE *in = fopen(fn, "r");
  if(in == NULL)
    return 1;

  x = 0;
  for(y = 0; y < 45; y++, level += 68) {
    fgets((char *)level, 66, in);
    if(level[0] != '1' && level[63] != '1') {
      fclose(in);
      return 2;
    }
  }

  fclose(in);
  return 0;
}



// Tytt 'level':in tunnelilla (0/48)
int tee_tyhja_leveli(unsigned char *level) {

  int x, y;

  for(y = 0; y < 45; y++) {
    if(y == 0 || y == 44)
      for(x = 0; x < 64; x++)
        level[y*68 + x] = '1';
    else
      for(x = 0; x < 64; x++) {
        if(x == 0 || x == 63)
          level[y*68 + x] = '1';
        else
          level[y*68 + x] = '0';
      }
    level[y*68 + 64] = '\n';
    level[y*68 + 65] = '\0';
    level[y*68 + 66] = '\0';
    level[y*68 + 67] = '\0';
  }

  return 0;
}



// Kirjoittaa 'level':in tiedostoon 'fn', saved kertoo, talletettiinko todella
int kirjota_leveli(char *fn, const unsigned char *level, int saved) {

  int x, y;
  char buf[80], temppi[13];

  if(fn[0] == '\0') {
    kysy_nimi(temppi, SAVE);

    if(temppi[0] == '\0') {
      rectfill(screen, 281, 6, 623, 38, 9);
      saved = 0;
      return saved;
    }
    else
      strcpy(fn, temppi);
  }

  FILE *out = fopen(fn, "w");
  if(out == NULL) {
    rectfill(screen, 281, 6, 623, 38, 9);
    sprintf(buf, "Failed to save \"%s\"", fn);
    textout(screen, font, buf, 286, 19, 0);
    fn[0] = '\0'; // jos failaa nimi tyhjks, kysytn ens kerralla
    saved = 0;
    return saved;
  }

  x = 0;
  saved = 0;
  for(y = 0; y < 45; y++, level += 68)
    if(fputs((char *)level, out) == EOF)
      return saved;

  fclose(out);
  rectfill(screen, 281, 6, 623, 38, 9);
  sprintf(buf, "\"%s\" saved", fn);
  textout(screen, font, buf, 286, 19, 0);
  saved = 1;

  return saved;
}

